/* ***** <NB> *****
 *
 * Огромнейшее человеческое спасибо:
 *      - Владимиру Паланту (http://xpoint.ru/forums/thread.xhtml?id=27554)
 *        и другим авторам "Adblock" (http://adblock.mozdev.org);
 *      - Авторам FlashBlock (http://flashblock.mozdev.org/).
 *
 * А так же:
 *      - Разработчикам Mozilla за предоставленную возможность
 *        порезвиться с js. Хотя лучше бы я просто поспал.
 *        (https://bugzilla.mozilla.org/show_bug.cgi?id=47475)
 *
 * Ну и
 *      "Всем тем, кто отдал свою душу Ветру..."
 *
 * ***** </NB> ***** */

/* ***** <Policy values> *****
 *
 * 1 -- Load all images
 * 2 -- Load images for this site only
 * 3 -- Load cached images only
 * 4 -- Don't load images
 *
 * ***** </Policy values> ***** */

var ILO = {
  
  browser:           getBrowser(),
  
  nsImgLikeopera:    Components.classes["@mozilla.org/imglikeopera;1"]
                               .createInstance(Components.interfaces.nsIImgLikeOpera),
  console:           Components.classes["@mozilla.org/consoleservice;1"]
                               .getService(Components.interfaces.nsIConsoleService),
  cacheImageService: Components.classes["@mozilla.org/image/cache;1"]
                               .getService(Components.interfaces.imgICache),
  cacheService:      Components.classes["@mozilla.org/network/cache-service;1"]
                               .getService(Components.interfaces.nsICacheService),
  observerService:   Components.classes["@mozilla.org/observer-service;1"]
                               .getService(Components.interfaces.nsIObserverService),
  prefService:       Components.classes["@mozilla.org/preferences-service;1"]
                               .getService(Components.interfaces.nsIPrefService),
  
  prefBranch:        "imglikeopera.",
  
  settings: {
    defaultPolicy: 3,
    tabsRefresh: false,
  },
  
  getXPCNativeWrappedJSObject: function(tab) {
    return new XPCNativeWrapper(tab.contentDocument.defaultView.document).wrappedJSObject;
  },
  
  /************************************************************************
   *
   * Taaabzzz games... ughhhh...
   *
   ************************************************************************/
  tabSelect: function() {
    var tab = this.browser.selectedBrowser;
    var doc = this.getXPCNativeWrappedJSObject(tab);
    if (tab.iloTabSelected) {
        if (tab.iloTabSelected == 1) {
            doc.iloUrlsBlock = doc.iloUrlsPass = "";
            
            //~ Refresh content in selected tab
            if (this.settings.tabsRefresh)
                this.refreshPageObjects(doc);
            
            tab.iloTabSelected = 3;
        }
        tab.iloTabSelected -= 1;
    }
    this.indicatorSet(tab.iloTabPolicy);
  },
  
  /************************************************************************
   *
   * Page indicator (bottom-right-button): popup, click
   *
   ************************************************************************/
  
  /** **************************** **
   **  2do, 2do, 2do...
   ** **************************** **/
  
  checkStatusbarClick: function(e) {
    switch (e.button) {
      case 1:
        this.openSettingsWindow();
        break;
      case 2:
        this.indicatorClick("-1");
        break;
      case 0:
        if (e.target.id == "ilo-statusbar-button-arrow")
          e.target.parentNode.lastChild.showPopup(e.target,-1,-1,"popup","bottomleft","topleft");
        else
          this.indicatorClick();
        break;
    }
  },

  //~ [Something from utilityOverlay.js]
  checkClick: function(node, event, button) {
    if (button) {
      if (event.button == 1)
        this.openSettingsWindow();
      else if (event.button == 2)
        this.indicatorClick("-1");
      return;
    }
    
    event.preventBubble();
    
    if (event.button == 1 && event.target.getAttribute("value")) {
        eval(node.getAttribute("oncommand"));
        this.closeMenus(event.target);
    }
  },

  closeMenus: function(node) {
    if ("tagName" in node) {
      if (node.namespaceURI == "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
                && (node.tagName == "menupopup" || node.tagName == "popup"))
        node.hidePopup();
      
      this.closeMenus(node.parentNode);
    }
  },

  openSettingsWindow: function() {
    var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                             .getService(Components.interfaces.nsIWindowMediator);
    var settingsWindow = mediator.getMostRecentWindow("imglikeoperaSettingsWindow");
    
    if (settingsWindow)
      settingsWindow.focus();
    else
      window.open("chrome://imglikeopera/content/options.xul","","chrome,centerscreen,resizable");
  },
  
  //~ "refresh" -- when called from 'nsImgLikeOpera::shouldLoad'
  indicatorClick: function(policy) {
    if (policy == "settings")
      return this.openSettingsWindow();
    
    var tab = this.browser.selectedBrowser;
    var doc = this.getXPCNativeWrappedJSObject(tab);
    
    if (!policy) {
      //~ left-mouse-click
      var policy = tab.iloTabPolicy - 1;
      if (policy == 0) policy = 4;
    } else if (policy == "-1") {
      //~ right-mouse-click
      policy = tab.iloTabPolicy + 1;
      if (policy == 5) policy = 1;
    }
    
    policy -= 0; //~ Numbers vs. Strings
    
    if (policy != tab.iloTabPolicy) {
      tab.iloTabPolicy = doc.iloDocPolicy = policy;
      doc.iloUrlsBlock = doc.iloUrlsPass = "";
      
      this.indicatorSet(policy);
      
      if (policy != 4)
        this.refreshPageObjects(doc);
    }
  },

  indicatorPopup: function() {
    var indicatorPopupItems = this.button.lastChild.childNodes;
    for (var k = 4; --k > -1;)
      indicatorPopupItems[k].setAttribute("checked", false);
    indicatorPopupItems[ 4 - this.browser.selectedBrowser.iloTabPolicy ].setAttribute("checked", true);
  },
  
  indicatorSet: function(policy) {
    var b = this.button;
    b.setAttribute("value", "policy" + policy);
    if (b.getAttribute("label"))
        b.setAttribute("label", "img: " + this.bundle.getString("buttonPolicy" + policy));
  },
  
  /************************************************************************
   *
   * 1) contentAreaContextMenu --> popupshowing --> ilo-context-menu-load-image
   * 2) ctrl + rigthMouseClick
   *
   ************************************************************************/

  loadImg: function(obj) {
    obj = obj || this.checkImageMap(gContextMenu.target) || gContextMenu.target;
    
    var objsrc = obj.getAttribute("ilo-full-src"); //~ need for inputs with type="image"
    
    if (!objsrc) return;
    
    var tab = this.browser.selectedBrowser;
    var doc = this.getXPCNativeWrappedJSObject(tab);
    
    var re = new RegExp(objsrc.replace(/(\.|\||\+|\?|\$|\(|\)|\[|\])/g,"\\\$1") + " ");
    doc.iloUrlsBlock = doc.iloUrlsBlock.replace(objsrc + " ", "");
    
    if (!re.test(doc.iloUrlsPass))
      doc.iloUrlsPass += objsrc + " ";
    
    //~ if policy == "Don't load images" ==> turn it to "Load from cache"
    if (tab.iloTabPolicy == 4) {
      tab.iloTabPolicy = doc.iloDocPolicy = 3;
      this.indicatorSet(3);
    }
    
    if (!obj.getAttribute("ilo-ph-fix")) {
      try {
        this.cacheImageService.clearCache(false);
        var cacheEntryDescriptor = this.cacheSession.openCacheEntry(objsrc,
                                   Components.interfaces.nsICacheEntryDescriptor,
                                   false);
        if (cacheEntryDescriptor) {
          cacheEntryDescriptor.doom();
          cacheEntryDescriptor.close();
        }
      }
      catch(ex){}
    }
    
    this.refreshPageObjects(doc, objsrc);
  },
  
  /************************************************************************
   *
   * Refresh images|styles in document
   *
   ************************************************************************/
 
  getAllDocs: function(frameset) {
    var docsArray = [frameset.document];
    for (var i = frameset.frames.length; --i > -1;)
      docsArray = docsArray.concat(this.getAllDocs(frameset.frames[i]));
    return docsArray;
  },

  refreshPageObjects: function(doc, objsrc) {
    //if (doc != window.content.document) return; //~ really need this "if"?
    if (doc.iloDocDelayLoad) {
      doc.iloDocPolicy = doc.iloDocDelayLoad;
      doc.iloDocDelayLoad = null;
      //~ objsrc = null;
    }
    
    var docs = this.getAllDocs(doc.defaultView);
    for (var i = docs.length; --i > -1;) {
      this.refreshObjectsInFrame(docs[i], objsrc);
      this.refreshStyles(docs[i]);
    }
  },
  
  getXPathVal: function(cType) {
    return cType == "application/xhtml+xml" ?
                    ["//html:", function() {return "http://www.w3.org/1999/xhtml"}] :
                    ["//", null];
  },
  
  refreshObjectsInFrame: function(doc, objsrc) {
    var elms, obj, i=0, xpath, _xpath = this.getXPathVal(doc.contentType);
    xpath = _xpath[0] + (objsrc ? "*[@ilo-full-src='" + objsrc + "']" : "*[@ilo-ph-fix]");
    elms = doc.evaluate(xpath, doc, _xpath[1], XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    for (; (obj = elms.snapshotItem(i)); i++) {
      /**________________________________________________________
          remove from "FOR" next line?
         ________________________________________________________
      **/
      objsrc ? obj.setAttribute("ilo-ph-fix", "mustLoad") : obj.removeAttribute("ilo-ph-fix");
      if (obj.getAttribute("src")) {
        obj.setAttribute("src", obj.getAttribute("src"));
      }
      else if (obj.getAttribute("data")) {
        var dbl = obj.cloneNode(true), parent = obj.parentNode;
        parent.insertBefore(dbl, obj);
        parent.removeChild(obj);
      }
    }
    
    if (!objsrc) return;
    
    //~ we need also refreshing other images for apply styles...
    //~ ugly, ugly, ugly!
    //~ UPDATE: надо проверить, нужно ли ещё это обновление стилей.
    //~ ...А пока не проверили -- return;
    
    return;
    
    xpath = _xpath[0] + "*[@ilo-full-src!='" + objsrc + "']";
    elms = doc.evaluate(xpath, doc, _xpath[1], XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    for (; (obj = elms.snapshotItem(i)); i++) {
      obj.setAttribute("ilo-ph-fix", "mustLoad");
      if (obj.getAttribute("src")) {
        obj.setAttribute("src", obj.getAttribute("src"));
      }
      else if (obj.getAttribute("data")) {
        var dbl = obj.cloneNode(true), parent = obj.parentNode;
        parent.insertBefore(dbl, obj);
        parent.removeChild(obj);
      }
    }
  },
  
  /** NOTE: Work since Fx1.5b2 only:
      https://bugzilla.mozilla.org/show_bug.cgi?id=308999
      Crash when changing node.style.background (with non-empty node.style.content)
      from JavaScript [@ nsStyleDisplay::CalcDifference ]
  **/
  refreshCssRules: function(sheet) {
    var node = sheet.cssRules;
    for (var i = node.length; --i > -1;) {
      if (node[i].styleSheet)
        this.refreshCssRules(node[i].styleSheet); //~ recursion
      else {
        if (/background.*url/.test(node[i].cssText))
          node[i].style.backgroundImage = node[i].style.backgroundImage;
        if (/list.*url/.test(node[i].cssText))
          node[i].style.listStyleImage = node[i].style.listStyleImage;
        if (/content:/.test(node[i].cssText))
          node[i].style.content = node[i].style.content;
      }
    }
  },
  
  refreshStyles: function(doc) {
    
    //~ inline styles
    
    var elms, obj=null, i=0, _xpath = this.getXPathVal(doc.contentType);
    _xpath[0] += "*[contains(@style,'url')]";
    elms = doc.evaluate(_xpath[0], doc, _xpath[1], XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    for (; (obj = elms.snapshotItem(i)); i++)
      obj.style.backgroundImage = obj.style.backgroundImage;
    
    //~ ugly styles like '<element background="image.jpg"'
    i=0, _xpath = this.getXPathVal(doc.contentType);
    _xpath[0] += "*[contains(@background,'.')]";
    elms = doc.evaluate(_xpath[0], doc, _xpath[1], XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    for (; (obj = elms.snapshotItem(i)); i++) {
      obj.setAttribute("style",
                       "background-image:url('" + obj.getAttribute("background") + "'); " +
                       (obj.getAttribute("style") == null ? "" : obj.getAttribute("style")));
      obj.removeAttribute("background");
    }
    
    //~ <link>, <style>, <xml-stylesheet>
    
    var stSNode, ssMedia, stS = doc.styleSheets;
    
    for (i=stS.length; --i > -1;) {
      ssMedia = stS[i].media.mediaText;
      if ("" == ssMedia || /screen|projection/.test(ssMedia)) {
        stSNode = stS[i].ownerNode;
        
        //~ stSNode.nodeName.toLowerCase() = "style"||"link"||"xml-stylesheet"
        //~    if "style"-node: test for inline @import rules,
        //~    like @import url("http://example.com/test.css")
        if (stSNode.nodeName.toLowerCase() == "style" && !/@import/.test(stSNode.textContent))
          stSNode.textContent = stSNode.textContent; //~ ...more simple and fast then other method
        else
          this.refreshCssRules(stS[i]);
      }
    }
  },
  
  onLoad: function() {
    window.removeEventListener("load", this.onLoad, true);
    
    //~ Set native browser policy: "Load All Images".
    this.prefService.getBranch("").setIntPref("permissions.default.image", 1);
    
    /** Bug 306243, https://bugzilla.mozilla.org/show_bug.cgi?id=306243
        When browser.tabs.autohide is enabled, toolbar customisation settings are
        ignored after restarting Firefox; extensions' icons are missing from the palette
    **/
    //~ this.prefService.getBranch("").setBoolPref("browser.tabs.autohide", false);
    
    this.branch = this.prefService.getBranch(this.prefBranch);
    
    this.observerService.addObserver(this,     "ILO-Load-Settings", false);
    this.observerService.notifyObservers(this, "ILO-Load-Settings", false);
    
    /* ***** Tabs hack [start] *****
     * was (in ILO 0.6.5-):
     * Patch "browser.addTab" [tabbrowser.xml, <method name="addTab">]
     * eval('gBrowser.addTab =' + this.browser.addTab.toString().replace(__tb_from, __tb_to));
     * ******************** */
    var __tb_from = 'if (!blank)';
    var __tb_to = 'b.iloTabPolicy = ILO.settings.defaultPolicy ? \
                                     ILO.settings.defaultPolicy : this.selectedBrowser.iloTabPolicy; \
                   b.iloTabSelected = 2; \
                   if (!blank)';
    
    if (this.browser.__tabextensions__addTab) {
    //~ for work with TBE (like tabextensions_2.0.2005121301_en.xpi) we need this lines:
      eval('gBrowser.__tabextensions__addTab =' + this.browser.__tabextensions__addTab.toString().replace(
        __tb_from,
        __tb_to
      ));
      
      eval('gBrowser.getTabInfo =' + this.browser.getTabInfo.toString().replace(
        'allowImages:aTab.allowImages,',
        'allowImages:aTab.allowImages, iloTabPolicy:b.iloTabPolicy,'
      ));
      
      eval('gBrowser.addTabWithTabInfo =' + this.browser.addTabWithTabInfo.toString().replace(
        'for (i in props)',
        'b.iloTabPolicy = aInfo.iloTabPolicy; ILO.indicatorSet(aInfo.iloTabPolicy); for (i in props)'
      ));
      
      eval('TabbrowserSessionManager.saveTabInfoTo =' + TabbrowserSessionManager.saveTabInfoTo.toString().replace(
        '"allowImages", aInfo.allowImages,',
        '"allowImages", aInfo.allowImages, "iloTabPolicy", aInfo.iloTabPolicy,'
      ));
      
      eval('TabbrowserSessionManager.loadTabInfoFrom =' + TabbrowserSessionManager.loadTabInfoFrom.toString().replace(
        'fixedLabel',
        'iloTabPolicy:Number(aDatabase.getData(aRes, "iloTabPolicy")), fixedLabel'
      ));
      
    } else {
    //~ no TBE:
      eval('gBrowser.addTab =' + this.browser.addTab.toString().replace(
        __tb_from,
        __tb_to
      ));
    }
    
    if (this.browser.__ssAddTabMod) {
    //~ for work with SessionSaver (like version 0.2.1.030.4) we need this lines:
      eval('SessionSaver.captureTab =' + SessionSaver.captureTab.toString().replace(
        'tab.__ssLocalData = tabSession;',
        'if (browser && browser.iloTabPolicy) tabSession += "##ILO##" + browser.iloTabPolicy; \
         tab.__ssLocalData = tabSession;'
      ));
      
      eval('SessionSaver.historyRecall =' + SessionSaver.historyRecall.toString().replace(
        'var historyURL = entry[1];',
        'var iloTabPolicy = entry[1].split("##ILO##")[1]; var historyURL = entry[1].split("##ILO##")[0];'
      ));
      
      eval('SessionSaver.historyRecall =' + SessionSaver.historyRecall.toString().replace(
        'if (isStartup && this.orbiterChild)',
        'curBrowser.iloTabPolicy=parseInt(iloTabPolicy); curBrowser.iloTabSelected = 2; \
         if (t == selectedtab) ILO.indicatorSet(curBrowser.iloTabPolicy); if (isStartup && this.orbiterChild)'
      ));
    }
    
    if (typeof SessionRestore != "undefined") {
    //~ for work with Tab Mix Plus (like tabmixplus-0.2.5.2.xpi) we need this lines:
      //~ this.log("Tab Mix Plus, SessionRestore!");
      
      //~ const gRDFLabelHistoryEntryILO = gRDFLabelHistoryEntry + "#ilo";
      
      //~ eval('SessionRestore.saveClosedTabs =' + SessionRestore.saveClosedTabs.toString().replace('entryContainer.AppendElement', 'dataSource.Assert(rdfNodeHistoryEntry, rdfService.GetResource(gRDFLabelHistoryEntryILO), rdfService.GetLiteral(this.closedTabs[i]), true); entryContainer.AppendElement'));
      
      //~ eval('SessionRestore.loadOneTab =' + SessionRestore.loadOneTab.toString().replace('this.tabIndex++;', 'this.tabIndex++; aTab.iloTabPolicy = "4"; ILO.indicatorSet(aTab.iloTabPolicy);'));
      //~ this.log(SessionRestore.saveClosedTabs.toString());
    }
    
    /* ***** Tabs hack [end] ***** */
    
    //~ yet another hack... is there a better way?..
    var hiddenWnd = Components.classes["@mozilla.org/appshell/appShellService;1"]
                              .getService(Components.interfaces.nsIAppShellService)
                              .hiddenDOMWindow;
    var _oldWindowOpenDialog = window.openDialog;
    window.openDialog = function() {
        try {
            hiddenWnd.iloOpenerPolicy = ILO.browser.selectedBrowser.iloTabPolicy;
        } catch(e){}
        
        var args = [];
        for (var i = 0; i < arguments.length; i++)
            args.push('arguments['+i+']');
        
        return eval('_oldWindowOpenDialog('+args.join(', ')+')');
    };
    
    var defPolicy;
    //~ hiddenWnd.iloOpenerPolicy not exist when program startup (first window).
    if (!this.settings.defaultPolicy) { //~ "From previous window/tab"
        defPolicy = hiddenWnd.iloOpenerPolicy ?
                    hiddenWnd.iloOpenerPolicy : this.branch.getIntPref("startup.policy");
    } else {
        defPolicy = this.settings.defaultPolicy;
    }
    
    //~ Current tab policy
    this.browser.selectedBrowser.iloTabPolicy = defPolicy;
    this.browser.selectedBrowser.iloTabSelected = 2;
    
    this.bundle = document.getElementById("ilo-string-bundle");
    
    this.setButton();
    
    var toolbox = document.getElementById("navigator-toolbox");
    toolbox.addEventListener("draggesture", function(){setTimeout("ILO.setButton()",0)}, false);
    toolbox.addEventListener("dragdrop",    function(){setTimeout("ILO.setButton()",0)}, false);
    
    //~ Page-indicator.
    this.indicatorSet(defPolicy);
    
    //~ Tabs switching.
    this.browser.addEventListener("select", function(){ILO.tabSelect();}, false);
    
    this.cacheSession = this.cacheService.createSession("HTTP",
                                          Components.interfaces.nsICache.STORE_ANYWHERE, true);
    this.cacheSession.doomEntriesIfExpired = false;
    
    //~ Context Menu: + "Load Image".
    //~ document.getElementById("context-viewimage").hidden = true;
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",
      function() {
        document.getElementById("ilo-context-menu-load-image").hidden =
              ((gContextMenu.target instanceof Components.interfaces.nsIImageLoadingContent &&
               gContextMenu.target.getAttribute("ilo-full-src")) ||
               ILO.checkImageMap(gContextMenu.target)) ? false : true;
      },
    false);
    
    window.addEventListener("click",
      function(e) {
        if (e.ctrlKey &&
            ((e.target instanceof Components.interfaces.nsIImageLoadingContent &&
              e.target.getAttribute("ilo-full-src")) ||
             ILO.checkImageMap(e.target)))
        {
          e.preventDefault();
          ILO.loadImg(ILO.checkImageMap(e.target) || e.target);
        }
      },
    false);
    
    window.addEventListener("keypress",
      function(e) {
        if (e.keyCode != 27) return; //~ "Esc"
        
        var doc = e.target.ownerDocument;
        while (doc.defaultView.frameElement) doc = doc.defaultView.frameElement.ownerDocument;
        
        var tab = ILO.browser.selectedBrowser;
        if (doc != ILO.getXPCNativeWrappedJSObject(tab)) return;
        
        var docShell = tab.docShell;
        docShell["allowImages"] = !docShell["allowImages"];
        docShell["allowImages"] = !docShell["allowImages"];
        
        //~ docShell["allowPlugins"] for active content?!
      },
    false);
  },
  
  //~ Check client-side image maps (the MAP and AREA elements)
  checkImageMap: function(obj) {
    if (obj.tagName != "AREA") return false;
    
    var map = obj.parentNode;
    if (map.tagName != "MAP" || !map.name) return false;
    
    var doc = obj.ownerDocument, xpath, _xpath = this.getXPathVal(doc.contentType);
    xpath = _xpath[0] + "*[@usemap='#" + map.name + "']";
    obj = doc.evaluate(xpath, doc, _xpath[1], XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null).snapshotItem(0);
    if (obj instanceof Components.interfaces.nsIImageLoadingContent && obj.getAttribute("ilo-full-src"))
      return obj;
    
    return false;
  },
  
  setButton: function() {
    var toolbarButton = document.getElementById("ilo-toolbar-button");
    var statusbarButton = document.getElementById("ilo-statusbar-button");
    
    if (toolbarButton) {
      this.button = toolbarButton;
      statusbarButton.parentNode.style.display = "none";
    } else {
      this.button = statusbarButton;
      statusbarButton.parentNode.style.display = "";
    }
    
    this.indicatorSet(this.browser.selectedBrowser.iloTabPolicy);
  },
  
  onToolbarDrags: function() {
    setTimeout(function(){ILO.setButton()},0);
  },
  
  observe: function (aSubject, aTopic, aState) {
    if (aTopic == "ILO-Load-Settings") {
      this.settings.defaultPolicy = this.branch.getIntPref("default.policy");
      this.settings.tabsRefresh   = this.branch.getBoolPref("tabs.refresh");
    }
  },
  
  unLoad: function() {
    this.observerService.removeObserver(this, "ILO-Load-Settings");
  },
  
  log: function(msg) { this.console.logStringMessage(msg); },
  
  delayLoadRefresher: function(e) {
    var doc = new XPCNativeWrapper(e.target).wrappedJSObject;
    //~ Searching TAB.policy for target document is the better
    //~ way for "hot" switching policies... isn't it?..
    
    if (!doc.iloDocDelayLoad) return;
    
    doc.iloDocPolicy = doc.iloDocDelayLoad;
    doc.iloDocDelayLoad = null;
    this.refreshPageObjects(doc);
  },
  
};

window.addEventListener("load",   function(){ILO.onLoad();}, false);
window.addEventListener("unload", function(){ILO.unLoad();}, false);
window.addEventListener("delayLoadRefresher", function(e){ILO.delayLoadRefresher(e);}, false);